SbName(3)

NAME
SbName - The SbName class stores strings by reference.

SYNOPSIS

#include <Inventor/SbName.h>

  Public Member Functions
SbName (void)
SbName (const char *namestring)
SbName (const SbString &str)
SbName (const SbName &name)
~SbName ()
const char * getString (void) const
int getLength (void) const
int operator! (void) const
operator const char * (void) const

  Static Public Member Functions
static SbBool isIdentStartChar (const char c)
static SbBool isIdentChar (const char c)
static SbBool isBaseNameStartChar (const char c)
static SbBool isBaseNameChar (const char c)
static const SbName & empty (void)

Detailed Description

The SbName class stores strings by reference. The class is used by Coin for storing keywords, names and other strings. They are stored in a manner where identical strings are guaranteed to map to the same memory address (as returned by the SbName::getString() method).

The main advantage of storing identical strings to the same memory address is that it simplifies comparison operations, and particularly when working with string data as keys in other data structures, like e.g. in hash (dictionary) tables.

Apart from that, mapping identical strings to the same memory address can also save on memory resources, and provide runtime optimizations. String comparisons for SbName objects are very efficient, for instance.

There is an aspect of using SbName instances that it is important to be aware of: since strings are stored permanently, using SbName instances in code where there is continually changing strings or the continual addition of new unique strings will in the end swamp memory resources. So where possible, use SbString instances instead.

See also
    SbString

Constructor & Destructor Documentation

  SbName::SbName (void )
This is the default constructor.

  SbName::SbName (const char * namestring)
Constructor. Adds the namestring string to the name table.

  SbName::SbName (const SbString & str)
Constructor. Adds str to the name table.

  SbName::SbName (const SbName & name)
Copy constructor.

  SbName::~SbName ()
The destructor.

Member Function Documentation

  const char * SbName::getString (void ) const
This method returns pointer to character array for the name.

The returned memory pointer for the character string is guaranteed to be valid for the remaining life time of the process, even after all SbName instances referencing the string have been destructed.

  int SbName::getLength (void ) const
This method returns the number of characters in the name.

  int SbName::operator! (void ) const
This unary operator results in FALSE if the SbName object is non-empty and TRUE if the SbName object is empty. An empty name contains a null-length string.

  SbName::operator const char * (void ) const
This operator returns a pointer to the character array for the name string. It is intended for implicit use. Use SbName::getString() explicitly instead of this operator - it might be removed later.

See also
    const char * SbName::getString(void)

  SbBool SbName::isIdentStartChar (const char c) [static]
This method checks if the c character is a valid identifier start character for a name.

See also
    SbBool SbName::isIdentChar(const char c)

  SbBool SbName::isIdentChar (const char c) [static]
This method checks if the c character is a valid character for a name.

See also
    SbBool SbName::isIdentStartChar(const char c)

  SbBool SbName::isBaseNameStartChar (const char c) [static]
Returns TRUE if the given character is valid for use as the first character of a name for an object derived from a class inheriting SoBase.

SoBase derived objects needs to be named in a manner which will not clash with the special characters reserved as tokens in the syntax rules of Open Inventor and VRML files.

Legal characters for the first character of an SoBase object name is underscore ("_") and any uppercase and lowercase alphabetic character from the ASCII character set (i.e. A-Z and a-z).

This method is not part of the original Open Inventor API.

See also
    isBaseNameChar()

  SbBool SbName::isBaseNameChar (const char c) [static]
Returns TRUE if the given character is valid for use in naming object instances of classes derived from SoBase.

SoBase derived objects needs to be named in a manner which will not clash with the special characters reserved as tokens in the syntax rules of Open Inventor and VRML files.

Legal characters to use for an SoBase object name is any character from the ASCII character set from and including character 33 (hex 0x21) to and including 126 (hex 0x7e), except single and double apostrophes, the plus sign and punctuation, backslash and the curly braces.

This method is not part of the original Open Inventor API.

See also
    isBaseNameStartChar()

  const SbName & SbName::empty (void ) [static]
Returns an empty-string SbName instance.

Since
    Coin 3.0

Author

Generated automatically by Doxygen for Coin from the source code.